<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>{{title}}</title>
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
    <meta name="description" content="Description">
    <meta name="viewport"
        content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <link rel="stylesheet" href="//unpkg.com/docsify/lib/themes/vue.css">
    <style>
        .sidebar {
            width: 22rem;
        }
    </style>
    <script src="https://code.jquery.com/jquery-3.4.1.min.js"
        integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo=" crossorigin="anonymous"></script>
</head>

<body>
    <nav>
        <div style="border: 2px solid red; border-radius: 0.5em; padding: 1em;">
            <div class="input-wrap">
                <input id="inGitlabToken" placeholder="Gitlab API Token" type="text" style="text-align: right;"
                    onchange="rememberGitlabToken()" /><br>
                <label for="inGitlabToken" id="lGitlabUser" style="font-size: 10pt; color:gray;">?</label>
            </div>
            <div class="input-wrap">
                <input id="inGitlabProjectId" placeholder="Gitlab Project ID" type="text" style="text-align: right;"
                    onchange="rememberGitlabProjectId()" /><br>
                <label for="inGitlabProjectId" id="lGitlabProjectNS" style="font-size: 10pt; color:gray;">?</label><br>
                <label for="inGitlabProjectId" id="lGitlabProjectName" style="font-size: 10pt; color:gray;">?</label>
            </div>
            <button id="btnCreateGitlabIssue"
                title="Shift gedrückt halten, um das Ticket unzugewiesen zu erstellen">Ticket anlegen</button>
        </div>
    </nav>
    <div id="app"></div>
    <script>
        let gitlab_url = '{{gitlab_url}}'
        let keyprefix = '{{title}}'.toLowerCase().trim().replace(/ /g, '-')

        $("#btnCreateGitlabIssue").click(createGitlabIssue);

        function getPrefixedLocalStorage(key) {
            return localStorage.getItem(`${keyprefix}/${key}`)
        }

        function setPrefixedLocalStorage(key, value) {
            localStorage.setItem(`${keyprefix}/${key}`, value)
        }

        function getParameterByName(name, url) {
            if (!url) url = window.location.href;
            name = name.replace(/[\[\]]/g, '\\$&');
            var regex = new RegExp('[?&]' + name + '(=([^&#]*)|&|#|$)'),
                results = regex.exec(url);
            if (!results) return null;
            if (!results[2]) return '';
            return decodeURIComponent(results[2].replace(/\+/g, ' '));
        }

        window.$docsify = {
            name: '{{title}}',
            loadSidebar: true,
            homepage: 'home.md',
            search: {
                maxAge: 86400000,
                paths: 'auto',
                depth: 6,
                placeholder: 'Search...',
                noDate: 'Not found!',
                namespace: keyprefix
            },
            plugins: [
                function (hook) {
                    hook.init(function () {
                        fetchUser();
                        var projectId = getParameterByName('projectId', null);
                        if (projectId) {
                            setPrefixedLocalStorage('gitlab_project_id', projectId);
                            document.getElementById('inGitlabProjectId').value = projectId;
                        }
                        fetchProject(getPrefixedLocalStorage('gitlab_project_id'));
                    });

                    hook.beforeEach(function (content) {
                        setPrefixedLocalStorage('markdown_content', content);

                        let createButton = document.getElementById("btnCreateGitlabIssue");
                        if (content.indexOf('gitlab.ddl.at/') == -1) {
                            // only actual steps have a gitlab repo link -> it shouldnt be possible to create tickets for the others
                            createButton.disabled = true;
                        } else {
                            createButton.disabled = false;
                        }
                    });

                    hook.afterEach(function (html, next) {
                        const full_regex = /(<p>){0,1}\/label (.*?)(?:(<\/p>)|($)|(<))/gm;
                        const label_regex = /~(?!&quot;)([^ ]+)/g;
                        const quot_regex = /~&quot;(.*?)&quot;/g;
                        var labels = []
                        for (const m of html.matchAll(full_regex)) {
                            var all_labels = m[2];
                            for (const n of all_labels.matchAll(label_regex)) {
                                labels.push(n[1]);
                            }
                            for (const n of all_labels.matchAll(quot_regex)) {
                                labels.push(n[1]);
                            }
                        }

                        main_label = '{{label}}';
                        if (main_label.length > 0) {
                            labels.push(main_label);
                        }
                        setPrefixedLocalStorage("labels", labels.join(','));

                        html = html.replace(full_regex, '');

                        next(html);
                    });
                }
            ],
        }

        function rememberGitlabToken() {
            localStorage.setItem("gitlab_token", document.getElementById('inGitlabToken').value);
            fetchUser();
        }

        function rememberGitlabProjectId() {
            var projectId = document.getElementById('inGitlabProjectId').value;
            setPrefixedLocalStorage("gitlab_project_id", projectId);
            fetchProject(projectId);
        }

        function rememberGitlabMilestone() {
            var projectId = document.getElementById('inGitlabProjectId').value;
            setPrefixedLocalStorage("gitlab_milestone_" + projectId, document.getElementById('inGitlabMilestone').value);
        }

        function fetchUser() {
            var token = localStorage.getItem("gitlab_token")

            $.ajax({
                type: "GET",
                url: `${gitlab_url}/api/v4/user/`,
                crossDomain: true,
                headers: {
                    'PRIVATE-TOKEN': token
                },
                success: function (data) {
                    document.getElementById('lGitlabUser').textContent = data.username;
                },
                error: function (xhr, textStatus, errorThrown) {
                    document.getElementById('lGitlabUser').textContent = '?';
                    console.log(errorThrown);
                }
            });
        }

        function fetchProject(projectId) {
            var token = localStorage.getItem("gitlab_token")

            $.ajax({
                type: "GET",
                url: `${gitlab_url}/api/v4/projects/${projectId}`,
                crossDomain: true,
                headers: {
                    'PRIVATE-TOKEN': token
                },
                success: function (data) {
                    document.getElementById('lGitlabProjectNS').textContent = data.namespace.name;
                    document.getElementById('lGitlabProjectName').textContent = data.name;
                },
                error: function (xhr, textStatus, errorThrown) {
                    document.getElementById('lGitlabProjectNS').textContent = '?';
                    document.getElementById('lGitlabProjectName').textContent = '?';
                    console.log(errorThrown);
                }
            });

            $.ajax({
                type: "GET",
                url: `${gitlab_url}/api/v4/projects/${projectId}/milestones?state=active`,
                crossDomain: true,
                headers: {
                    'PRIVATE-TOKEN': token
                },
                success: function (data) {
                    select = document.getElementById('inGitlabMilestone');
                    select.textContent = '';
                    if (data.length == 0) {
                        select.setAttribute('hidden', 'true')
                    } else {
                        select.removeAttribute('hidden')
                        var opt = document.createElement('option');
                        opt.value = '';
                        opt.innerHTML = 'Kein Meilenstein';
                        select.appendChild(opt);
                        for (m of data) {
                            opt = document.createElement('option');
                            opt.value = m.title;
                            opt.innerHTML = m.title;
                            select.appendChild(opt);
                        }
                        select.value = getPrefixedLocalStorage('gitlab_milestone_' + projectId);
                        if (!select.value) {
                            select.value = "";
                        }
                    }
                },
                error: function (xhr, textStatus, errorThrown) {
                    document.getElementById('inGitlabMilestone').setAttribute('hidden', 'true');
                    console.log(errorThrown);
                }
            });
        }

        function wasRecentlyCreated() {
            var last_timestamp = getPrefixedLocalStorage("last_timestamp")
            var last_content = getPrefixedLocalStorage("last_content")
            var last_project = getPrefixedLocalStorage("last_project")
            var markdown_content = getPrefixedLocalStorage("markdown_content")
            var projectId = document.getElementById('inGitlabProjectId').value;

            if (last_content === markdown_content && last_project === projectId) {
                var diff = Date.now() - last_timestamp
                if (diff < 5 * 60 * 1000) {
                    return true
                }
            }

            return false
        }

        function createGitlabIssue(e) {
            if (wasRecentlyCreated()) {
                if (window.confirm('This ticket was already created less than 5 minutes ago.')) {
                    window.open(getPrefixedLocalStorage("last_url"), '_blank');
                }
                return
            }

            var token = localStorage.getItem("gitlab_token")

            var projectId = getPrefixedLocalStorage("gitlab_project_id");
            var milestone = getPrefixedLocalStorage("gitlab_milestone_" + projectId);
            var labels = getPrefixedLocalStorage("labels");
            var markdown_content = getPrefixedLocalStorage("markdown_content")
            if (!e.shiftKey) {
                markdown_content += "\n\n/assign me" //add quickaction to assign ticket
            }
            markdown_content += "\n\n/milestone %\"" + milestone + "\""

            replaced_content = markdown_content
            //Replace variables
            projectId = getPrefixedLocalStorage('gitlab_project_id');
            if (projectId) {
                replaced_content = replaced_content.replace(/\{\{projectId\}\}/g, projectId);
            }
            if (milestone) {
                replaced_content = replaced_content.replace(/\{\{milestone\}\}/g, milestone);
            }

            var content = replaced_content.split('\n');

            $.ajax({
                type: "POST",
                url: `${gitlab_url}/api/v4/projects/${projectId}/issues`,
                crossDomain: true,
                headers: {
                    'PRIVATE-TOKEN': token
                },
                data: {
                    "project_id": projectId,
                    "title": content[0].replace('#', '').trim(),
                    "description": content.slice(1).join('\n'),
                    "labels": labels
                },
                success: function (data) {
                    setPrefixedLocalStorage("last_timestamp", Date.now())
                    setPrefixedLocalStorage("last_url", data.web_url)
                    setPrefixedLocalStorage("last_project", projectId)
                    setPrefixedLocalStorage("last_content", getPrefixedLocalStorage("markdown_content"))
                    window.open(data.web_url, '_blank')
                },
                fail: function (xhr, textStatus, errorThrown) {
                    console.log(errorThrown);
                }
            });
        }

        (function () {
            var projectId = getPrefixedLocalStorage("gitlab_project_id");
            document.getElementById("inGitlabProjectId").value = projectId;
            document.getElementById("inGitlabToken").value = localStorage.getItem("gitlab_token");
        })();
    </script>
    <script src="https://cdn.jsdelivr.net/npm/docsify@4"></script>
    <script src="https://cdn.jsdelivr.net/npm/docsify@4/lib/plugins/search.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/docsify@4/lib/plugins/emoji.min.js"></script>

    <script>
    </script>
</body>

</html>